## insighttoolkit5 5.4.3

=== Examples/Numerics/CMakeLists.txt ===
project(NumericsExamples)

add_executable(FourierDescriptors1 FourierDescriptors1.cxx)
target_link_libraries(FourierDescriptors1 ${ITK_LIBRARIES})

=== Examples/RegistrationITKv4/test/CMakeLists.txt ===
set(BASELINE ${ITK_DATA_ROOT}/Baseline/Registration)
set(TEMP ${ITK_BINARY_DIR}/Testing/Temporary)

itk_add_test(
  NAME
  ImageRegistrationHistogramPlotterTest
  COMMAND
  ${ITK_TEST_DRIVER}
  --compareNumberOfPixelsTolerance
  30
  --compareIntensityTolerance
  10
  --compareRadiusTolerance
  10
  --compare
  DATA{${BASELINE}/JointEntropyHistogramAfterRegistration.png,:}
  ${TEMP}/JointEntropyHistogramAfterRegistration.png
  $<TARGET_FILE:ImageRegistrationHistogramPlotter>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainT1SliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/RegisteredImage.png
  0
  ${TEMP}/JointEntropyHistogramPriorToRegistration.png
  ${TEMP}/JointEntropyHistogramAfterRegistration.png
  512)
set_property(
  TEST ImageRegistrationHistogramPlotterTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration1Test1
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration1TestPixelCentered.png}
  ${TEMP}/ImageRegistration1Test1PixelCentered.png
  $<TARGET_FILE:ImageRegistration1>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration1Test1PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceAfterTest1PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceBeforeTest1PixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration1Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration1TestPixelCentered.png}
  ${TEMP}/ImageRegistration1Test2PixelCentered.png
  $<TARGET_FILE:ImageRegistration1>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration1Test2PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceAfterTest2PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceBeforeTest2PixelCentered.png
  1)

itk_add_test(
  NAME
  ImageRegistration2Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration2Test.png}
  ${TEMP}/ImageRegistration2Test.png
  $<TARGET_FILE:ImageRegistration2>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainT1SliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration2Test.png
  ${TEMP}/ImageRegistration2BeforeTest.png
  ${TEMP}/ImageRegistration2AfterTest.png)
set_property(
  TEST ImageRegistration2Test
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration3Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration3TestPixelCentered.png}
  ${TEMP}/ImageRegistration3TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration3>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration3TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration4Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration4Test.png}
  ${TEMP}/ImageRegistration4Test.png
  $<TARGET_FILE:ImageRegistration4>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainT1SliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration4Test.png
  0
  ${TEMP}/ImageRegistration4BeforeTest.png
  ${TEMP}/ImageRegistration4AfterTest.png
  24)

itk_add_test(
  NAME
  ImageRegistration4Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  $<TARGET_FILE:ImageRegistration4>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20Mask.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20Mask.png
  ${TEMP}/ImageRegistration4Test2.png
  0
  ${TEMP}/ImageRegistration4BeforeTest2.png
  ${TEMP}/ImageRegistration4AfterTest2.png
  5)

itk_add_test(
  NAME
  ImageRegistration5Test1
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration5Test1PixelCentered.png}
  ${TEMP}/ImageRegistration5Test1PixelCentered.png
  --compareNumberOfPixelsTolerance
  115
  $<TARGET_FILE:ImageRegistration5>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceRotated10.png
  ${TEMP}/ImageRegistration5Test1PixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration5Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration5Test2PixelCentered.png}
  ${TEMP}/ImageRegistration5Test2PixelCentered.png
  $<TARGET_FILE:ImageRegistration5>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration5Test2PixelCentered.png
  ${TEMP}/ImageRegistration5Test2DifferenceAfter.png
  ${TEMP}/ImageRegistration5Test2DifferenceBefore.png
  1.3)

itk_add_test(
  NAME
  ImageRegistration6Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration6TestPixelCentered.png}
  ${TEMP}/ImageRegistration6TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  100
  $<TARGET_FILE:ImageRegistration6>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration6TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration7Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration7TestPixelCentered.png}
  ${TEMP}/ImageRegistration7TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  100
  $<TARGET_FILE:ImageRegistration7>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17S12.png
  ${TEMP}/ImageRegistration7TestPixelCentered.png
  ${TEMP}/ImageRegistration7BeforeTestPixelCentered.png
  ${TEMP}/ImageRegistration7AfterTestPixelCentered.png
  1.0
  1.0
  0.0)

if(ITK_USE_BRAINWEB_DATA)

  ## A test needed to prepare for making the latex documentation.
  itk_add_test(
    NAME
    ConfidenceConnected3DTest
    COMMAND
    ${ITK_TEST_DRIVER}
    $<TARGET_FILE:ConfidenceConnected3D>
    DATA{../../Data/BrainWeb/brainweb165a10f17.mha}
    ${TEMP}/WhiteMatterSegmentation.mhd)

  itk_add_test(
    NAME
    ImageRegistration8Test
    COMMAND
    ${ITK_TEST_DRIVER}
    --compare
    DATA{${BASELINE}/ImageRegistration8RegisteredSlice.png}
    ${TEMP}/ImageRegistration8v4RegisteredSlice.png
    $<TARGET_FILE:ImageRegistration8>
    DATA{../../Data/BrainWeb/brainweb1e1a10f20.mha}
    DATA{../../Data/BrainWeb/brainweb1e1a10f20Rot10Tx15.mha}
    ${TEMP}/ImageRegistration8v4Output.mhd
    ${TEMP}/ImageRegistration8v4DifferenceBefore.mhd
    ${TEMP}/ImageRegistration8v4DifferenceAfter.mhd
    ${TEMP}/ImageRegistration8v4Output.png
    ${TEMP}/ImageRegistration8v4DifferenceBefore.png
    ${TEMP}/ImageRegistration8v4DifferenceAfter.png
    ${TEMP}/ImageRegistration8v4RegisteredSlice.png)
  set_property(
    TEST ImageRegistration8Test
    APPEND
    PROPERTY LABELS RUNS_LONG)

  if(${CMAKE_BUILD_TYPE} MATCHES "Release")
    # This test is computationally demanding.
    # Therefore we only run it in a Release build
    itk_add_test(
      NAME
      ImageRegistration20Test
      COMMAND
      ${ITK_TEST_DRIVER}
      $<TARGET_FILE:ImageRegistration20>
      DATA{../../Data/BrainWeb/brainweb1e1a10f20.mha}
      DATA{../../Data/BrainWeb/brainweb1e1a10f20Rot10Tx15.mha}
      ${TEMP}/ImageRegistration20Output.mhd
      ${TEMP}/ImageRegistration20DifferenceBefore.mhd
      ${TEMP}/ImageRegistration20DifferenceAfter.mhd
      0.1 # Step length
      300 # maximum number of iterations
    )
    set_tests_properties(ImageRegistration20Test PROPERTIES RUN_SERIAL 1)
  endif()

endif()

itk_add_test(
  NAME
  ImageRegistration9Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration9TestPixelCentered.png}
  ${TEMP}/ImageRegistration9TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  50
  $<TARGET_FILE:ImageRegistration9>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration9TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration10Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration10TestPixelCentered.png,:}
  ${TEMP}/ImageRegistration10TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration10>
  DATA{${ITK_SOURCE_DIR}/Testing/Data/Baseline/Segmentation/WatershedSegmentation1Test1.png}
  DATA{${ITK_SOURCE_DIR}/Testing/Data/Baseline/Segmentation/WatershedSegmentation1Test2.png}
  ${TEMP}/ImageRegistration10TestPixelCentered.png
  ${TEMP}/ImageRegistration10DifferenceTestPixelCentered.png
  -11
  -13)

itk_add_test(
  NAME
  ImageRegistration13Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration13TestPixelCentered.png}
  ${TEMP}/ImageRegistration13TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  35
  $<TARGET_FILE:ImageRegistration13>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration13TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration14Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration14Test.png,:}
  ${TEMP}/ImageRegistration14Test.png
  --compareNumberOfPixelsTolerance
  2000
  $<TARGET_FILE:ImageRegistration14>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration14Test.png
  32
  0.01
  0.1
  0.15
  10.0
  14.0)
set_property(
  TEST ImageRegistration14Test
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration15Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration15TestPixelCentered.png}
  ${TEMP}/ImageRegistration15TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration15>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration15TestPixelCentered.png
  32
  0.1
  0.05
  0.0
  0.0)
set_property(
  TEST ImageRegistration15Test
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration16Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration16TestPixelCentered.png}
  ${TEMP}/ImageRegistration16TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration16>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration16TestPixelCentered.png
  0.0
  0.0)

itk_add_test(
  NAME
  ImageRegistration16Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration16TestPixelCentered.png}
  ${TEMP}/ImageRegistration16Test2PixelCentered.png
  $<TARGET_FILE:ImageRegistration16>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration16Test2PixelCentered.png
  0.0
  0.0
  0)

itk_add_test(
  NAME
  ImageRegistration17Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration17TestPixelCentered.png,:}
  ${TEMP}/ImageRegistration17TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  5
  $<TARGET_FILE:ImageRegistration17>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration17TestPixelCentered.png
  0.0
  0.0)

itk_add_test(
  NAME
  ImageRegistration18Test
  COMMAND
  ImageRegistration18
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png

=== Modules/Filtering/MathematicalMorphology/CMakeLists.txt ===
project(ITKMathematicalMorphology)
set(ITKMathematicalMorphology_LIBRARIES ITKMathematicalMorphology)
itk_module_impl()

=== Modules/IO/TransformMINC/CMakeLists.txt ===
project(ITKIOTransformMINC)
set(ITKIOTransformMINC_LIBRARIES ITKIOTransformMINC)

if(NOT ITK_USE_SYSTEM_HDF5)
  include_directories("${ITKHDF5_SOURCE_DIR}/src/itkhdf5" "${ITKHDF5_SOURCE_DIR}/src/itkhdf5/src"
                      "${ITKHDF5_BINARY_DIR}/src/itkhdf5")
endif()

itk_module_impl()

=== Modules/Registration/Common/CMakeLists.txt ===
project(ITKRegistrationCommon)
itk_module_impl()

=== Modules/Registration/GPUPDEDeformable/CMakeLists.txt ===
project(ITKGPUPDEDeformableRegistration)

if(ITK_USE_GPU)
  set(ITKGPUPDEDeformableRegistration_LIBRARIES ITKGPUPDEDeformableRegistration)
  set(ITKGPUPDEDeformableRegistration_SYSTEM_INCLUDE_DIRS ${OPENCL_INCLUDE_DIRS})
  set(ITKGPUPDEDeformableRegistration_SYSTEM_LIBRARY_DIRS ${OPENCL_LIBRARIES})
endif()

itk_module_impl()

=== Wrapping/Generators/Python/CMakeLists.txt ===
###############################################################################
#
## Desired directory layout for python package
##
## ${BLD_DIR}/
##    Wrapping/Modules/ITK${MODULE}/itk${MODULE_ITEM}Python.cpp # Generated by swig
##    Wrapping/Generator/Python/
##      - WrapITK.pth    # A path file that should point to this directory (cmake configured dynamically)
##      - itkConfig.py   # cmake configured file with paths, and dynamic compile time choices
##      - itk/
##        - __init__.py  # cmake copied file
##        - support/
##          - itk(Extras|Template|Base|LazyLoading|...).py # static python files cmake copied
##        - Configuration/
##          -- ITK${MODULE_ITEM}Config.py # igenerator.py output config database index files for .so
##          -- ITK${MODULE_ITEM}_snake_case.py # igenerator.py output config database index files for .so
##        - ITK${MODULE_ITEM}Python.py    # swig generated file
##        - _ITK${MODULE}.so              # swig python wrapped shared lib functions, copied here manually

include_directories("${Python3_INCLUDE_DIRS}")

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

include(itkTargetLinkLibrariesWithDynamicLookup)

###############################################################################
# store the current dir, so it can be reused later
set(ITK_WRAP_PYTHON_SOURCE_DIR
    "${CMAKE_CURRENT_SOURCE_DIR}"
    CACHE INTERNAL "python source dir")

###############################################################################
# create the python directory in the classindex dir
file(MAKE_DIRECTORY ${WRAPPER_MASTER_INDEX_OUTPUT_DIR}/python)

###############################################################################
# Configure Python wrapping installation
if(Python3_EXECUTABLE AND NOT PY_SITE_PACKAGES_PATH)
  set(python_check "try:\n    import sysconfig\n    print(sysconfig.get_path('platlib'))\nexcept:\n    pass")
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/detect_site_package_path.py ${python_check})
  execute_process(
    COMMAND "${Python3_EXECUTABLE}" "${CMAKE_CURRENT_BINARY_DIR}/detect_site_package_path.py"
    OUTPUT_VARIABLE py_spp
    ERROR_VARIABLE py_spp)

  execute_process(
    COMMAND "${Python3_EXECUTABLE}" -c "import sys\nprint(sys.prefix)"
    OUTPUT_VARIABLE py_prefix
    ERROR_VARIABLE py_prefix
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT
     "${CMAKE_INSTALL_PREFIX}"
     STREQUAL
     "${py_prefix}")
    install(
      CODE "message(WARNING \"CMAKE_INSTALL_PREFIX, ${CMAKE_INSTALL_PREFIX}, does not match Python's prefix, ${py_prefix}\")"
    )
  endif()
  string(
    REGEX
    REPLACE "\n"
            ""
            py_spp_no_newline
            "${py_spp}")
  file(TO_CMAKE_PATH "${py_spp_no_newline}" py_spp_nobackslashes)

  set(PY_SITE_PACKAGES_PATH
      "${py_spp_nobackslashes}"
      CACHE STRING "Python site-packages directory to install Python bindings.")
  mark_as_advanced(PY_SITE_PACKAGES_PATH)
endif()

if(NOT PY_SITE_PACKAGES_PATH)
  message(SEND_ERROR "Please set PY_SITE_PACKAGES_PATH to the Python bindings installation directory.")
endif()

macro(WRAP_ITK_PYTHON_BINDINGS_INSTALL path wrapper_library_name)
  set(_component_module "")
  if(WRAP_ITK_INSTALL_COMPONENT_PER_MODULE)
    if("${wrapper_library_name}" MATCHES "^ITK(PyUtils|PyBase)$")
      set(_component_module "ITKCommon")
    else()
      set(_component_module "${wrapper_library_name}")
    endif()
  endif()
  install(
    FILES ${ARGN}
    DESTINATION "${PY_SITE_PACKAGES_PATH}/${path}"
    COMPONENT ${_component_module}${WRAP_ITK_INSTALL_COMPONENT_IDENTIFIER}RuntimeLibraries)
  unset(_component_module)
endmacro()

###############################################################################
# Configure the path-dependent itkConfig.py

# we specify these directories with relative paths  so that the file can be
# bundled up into an install conventiently. Python will take care of turning
# the / path separator into \ on windows if needed.
if(NOT EXTERNAL_WRAP_ITK_PROJECT)

  # copy the files to expose build options in python
  set(ITK_WRAP_PYTHON_VECTOR_REAL)
  foreach(t ${WRAP_ITK_VECTOR_REAL})
    foreach(d ${ITK_WRAP_IMAGE_DIMS})
      list(APPEND ITK_WRAP_PYTHON_VECTOR_REAL ${ITKT_${t}${d}})
    endforeach()
  endforeach()
  set(ITK_WRAP_PYTHON_COV_VECTOR_REAL)
  foreach(t ${WRAP_ITK_COV_VECTOR_REAL})
    foreach(d ${ITK_WRAP_IMAGE_DIMS})
      list(APPEND ITK_WRAP_PYTHON_COV_VECTOR_REAL ${ITKT_${t}${d}})
    endforeach()
  endforeach()
  set(ITK_WRAP_PYTHON_RGB)
  foreach(t ${WRAP_ITK_RGB})
    list(APPEND ITK_WRAP_PYTHON_RGB ${ITKT_${t}})
  endforeach()
  set(ITK_WRAP_PYTHON_RGBA)
  foreach(t ${WRAP_ITK_RGBA})
    list(APPEND ITK_WRAP_PYTHON_RGBA ${ITKT_${t}})
  endforeach()
  set(ITK_WRAP_PYTHON_COMPLEX_REAL)
  foreach(t ${WRAP_ITK_COMPLEX_REAL})
    list(APPEND ITK_WRAP_PYTHON_COMPLEX_REAL ${ITKT_${t}})
  endforeach()

  file(
    RELATIVE_PATH
    CONFIG_PYTHON_CONFIGPY_DIR
    ${ITK_WRAP_PYTHON_ROOT_BINARY_DIR}
    ${ITK_WRAP_PYTHON_SWIG_CONFIGURATION_DIR})
  file(
    RELATIVE_PATH
    CONFIG_PYTHON_SWIGPY_DIR
    ${ITK_WRAP_PYTHON_ROOT_BINARY_DIR}
    ${ITK_PYTHON_PACKAGE_DIR})
  file(
    RELATIVE_PATH
    CONFIG_PYTHON_SWIGLIB_DIR
    ${ITK_WRAP_PYTHON_ROOT_BINARY_DIR}
    ${ITK_PYTHON_PACKAGE_DIR})

  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/itkConfig.py.in" "${ITK_WRAP_PYTHON_ROOT_BINARY_DIR}/itkConfig.py" @ONLY)

  wrap_itk_python_bindings_install(/ "ITKCommon" "${ITK_WRAP_PYTHON_ROOT_BINARY_DIR}/itkConfig.py")
endif()

###############################################################################
# Copy python files for out-of-source builds, and set up install of same.

if(NOT EXTERNAL_WRAP_ITK_PROJECT)
  set(ITK_PYTHON_SUPPORT_MODULES
      support/base
      support/template_class
      support/types
      support/extras
      support/xarray
      support/lazy
      support/helpers
      support/init_helpers
      support/build_options)
  set(ITK_INIT_MODULE "${CMAKE_CURRENT_SOURCE_DIR}/itk/__init__.py")
  set(ITK_CONFIGURATION_INIT_MODULE "${ITK_PYTHON_PACKAGE_DIR}/Configuration/__init__.py")
  # Done listing files.
  # Now copy these files if necessary.

  # If not an in-source build
  if(NOT
     "${WrapITK_BINARY_DIR}"
     MATCHES
     "^${WrapITK_SOURCE_DIR}$")
    set(ITK_WRAP_PYTHON_FILES)
    foreach(_file ${ITK_PYTHON_SUPPORT_MODULES})
      set(src "${CMAKE_CURRENT_SOURCE_DIR}/itk/${_file}.py")
      set(copy_tgt "${ITK_PYTHON_PACKAGE_DIR}/${_file}.py")
      list(APPEND ITK_WRAP_PYTHON_FILES "${copy_tgt}")

      # In a multi-config build, libraries are generated in config subdirectories to keep them separate
      # We must copy those separate files to a common python compatible tree.
      # NOTE: THE LAST RUN Build Config will overwrite the current files in the python package tree.
      add_custom_command(
        OUTPUT ${copy_tgt}
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${copy_tgt}
        DEPENDS ${src}
        COMMENT "Copying ${_file}.py to ${copy_tgt}.")
    endforeach()
    set(src "${ITK_INIT_MODULE}")
    set(copy_tgt "${ITK_PYTHON_PACKAGE_DIR}/__init__.py")
    list(APPEND ITK_WRAP_PYTHON_FILES "${copy_tgt}")
    add_custom_command(
      OUTPUT ${copy_tgt}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${copy_tgt}
      DEPENDS ${src}
      COMMENT "Copying __init__.py to ${copy_tgt}.")
    add_custom_target(copy_python_files ALL DEPENDS ${ITK_WRAP_PYTHON_FILES})
    file(WRITE "${ITK_CONFIGURATION_INIT_MODULE}" "")
  endif()

  # Install the package python files.
  set(ITK_WRAP_PYTHON_FILES)
  foreach(_file ${ITK_PYTHON_SUPPORT_MODULES})
    set(install_tgt "${CMAKE_CURRENT_SOURCE_DIR}/itk/${_file}.py")
    list(
      APPEND
      ITK_WRAP_PYTHON_FILES
      ${ITK_WRAP_PYTHON_FILES}
      "${install_tgt}")
  endforeach()
  wrap_itk_python_bindings_install(/itk/support "ITKCommon" ${ITK_WRAP_PYTHON_FILES})
  wrap_itk_python_bindings_install(/itk/Configuration "ITKCommon" "${ITK_CONFIGURATION_INIT_MODULE}")
  wrap_itk_python_bindings_install(/itk "ITKCommon" ${ITK_INIT_MODULE})
  install(DIRECTORY ${ITK_STUB_DIR}/ DESTINATION ${PY_SITE_PACKAGES_PATH}/${ITK_STUB_BASENAME})
endif()

###############################################################################
# Configure and install the custom python .pth files

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/WrapITK.pth.in" "${ITK_WRAP_PYTHON_ROOT_BINARY_DIR}/WrapITK.pth" @ONLY)

###############################################################################
# Define the wrapping macros

macro(
  itk_setup_swig_python
  type
  base_name
  interface_file
  python_file
  cpp_file
  doc_file)

  #############################################################################
  # Runs swig to produce the *Python.cpp and the *Python.py file
  # Called by itk_end_wrap_module_python and by itk_end_wrap_submodule_python
  # Type will then be either "Module" or "Submodule"
  #############################################################################

  set(swig_command ${SWIG_EXECUTABLE})
  if(ITK_USE_CCACHE)
    set(swig_command ${CCACHE_EXECUTABLE} ${swig_command})
  endif()

  set(_swig_depend)
  if(NOT ITK_USE_SYSTEM_SWIG)
    # The ExternalProject SWIG install.
    set(_swig_depend swig)
  endif()

  set(dependencies "${DEPS}" "${interface_file}" "${_swig_depend}")

  unset(_swig_depend)

  if(NOT EXTERNAL_WRAP_ITK_PROJECT)
    configure_file(${WrapITK_SOURCE_DIR}/Generators/Python/PyBase/pyBase.i "${WRAP_ITK_TYPEDEFS_DIRECTORY}" COPYONLY)
    list(APPEND dependencies "${WRAP_ITK_TYPEDEFS_DIRECTORY}/pyBase.i")
  endif()

  if("${type}" STREQUAL "Module")
    # Module
    list(
      APPEND
      dependencies
      "${ITK_WRAP_PYTHON_LIBRARY_DEPS}"
      "${WRAPPER_MASTER_INDEX_OUTPUT_DIR}/python/${WRAPPER_LIBRARY_NAME}_ext.i")
  else()
    # Submodule
    list(
      APPEND
      dependencies
      "${WRAPPER_MASTER_INDEX_OUTPUT_DIR}/python/${base_name}_ext.i"
      "${doc_file}")
  endif()

  add_custom_command(
    OUTPUT ${cpp_file} ${python_file}
    COMMAND
      ${swig_command} -c++ -python -fastdispatch -fvirtual -features autodoc=2 -doxygen -Werror
      -w302 # Identifier 'name' redefined (ignored)
      -w303 # %extend defined for an undeclared class 'name' (to avoid warning about customization in pyBase.i)
      -w312 # Unnamed nested class not currently supported (ignored)
      -w314 # 'identifier' is a lang keyword
      -w361 # operator! ignored
      -w362 # operator= ignored
      -w350 # operator new ignored
      -w383 # operator++ ignored
      -w384 # operator-- ignored
      -w389 # operator[] ignored
      -w394 # operator new[] ignored
      -w395 # operator delete[] ignored
      -w467 # Overloaded declaration not supported (no type checking rule for 'type')
      -w508 # Declaration of 'name' shadows declaration accessible via operator->(), previous declaration of'declaration'
      -w509 # Overloaded method declaration effectively ignored, as it is shadowed by declaration
      -o ${cpp_file}
      # The order of this include folder and the next one matters as otherwise the following exception is thrown:
      # "This version of exception.i should not be used"
      -I${SWIG_DIR}/python -I${SWIG_DIR} -I${WRAP_ITK_CMAKE_DIR}/Generators -I${WRAP_ITK_TYPEDEFS_DIRECTORY}/python
      -I${WRAP_ITK_TYPEDEFS_DIRECTORY} ${WRAP_ITK_SWIG_ARGS_PYTHON} -outdir ${ITK_PYTHON_PACKAGE_DIR} ${interface_file}
    WORKING_DIRECTORY ${WRAPPER_MASTER_INDEX_OUTPUT_DIR}/python
    DEPENDS ${dependencies})

  wrap_itk_python_bindings_install(/itk "${WRAPPER_LIBRARY_NAME}" "${python_file}")

  unset(dependencies)
  unset(swig_command)
endmacro()

macro(itk_end_wrap_submodule_python group_name)

  # base_name may be used in other macros
  set(base_name ${group_name})

  if("${group_name}" STREQUAL "ITKQuadEdgeMeshBase")
    # add a template definition for the superclass which is not in ITK
    set(text)
    foreach(d ${ITK_WRAP_IMAGE_DIMS})
      set(text

=== Modules/Filtering/Convolution/test/CMakeLists.txt ===
itk_module_test()
set(ITKConvolutionTests
    itkConvolutionImageFilterTest.cxx
    itkConvolutionImageFilterTestInt.cxx
    itkConvolutionImageFilterDeltaFunctionTest.cxx
    itkConvolutionImageFilterStreamingTest.cxx
    itkConvolutionImageFilterSubregionTest.cxx
    itkFFTConvolutionImageFilterTest.cxx
    itkFFTConvolutionImageFilterTestInt.cxx
    itkFFTConvolutionImageFilterDeltaFunctionTest.cxx
    itkNormalizedCorrelationImageFilterTest.cxx
    itkMaskedFFTNormalizedCorrelationImageFilterTest.cxx
    itkFFTNormalizedCorrelationImageFilterTest.cxx)

createtestdriver(ITKConvolution "${ITKConvolution-Test_LIBRARIES}" "${ITKConvolutionTests}")

itk_add_test(
  NAME
  itkConvolutionImageFilterTestSobelX
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTestSobelX.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTestSobelX.nrrd
  itkConvolutionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/sobel_x.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTestSobelX.nrrd)
itk_add_test(
  NAME
  itkConvolutionImageFilterTestSobelY
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTestSobelY.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTestSobelY.nrrd
  itkConvolutionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/sobel_y.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTestSobelY.nrrd)
itk_add_test(
  NAME
  itkConvolutionImageFilterTest4x4Mean
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest4x4Mean.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x4Mean.png
  itkConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x4-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x4Mean.png
  1
  SAME)
itk_add_test(
  NAME
  itkConvolutionImageFilterTest4x5Mean
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest4x5Mean.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x5Mean.png
  itkConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x5Mean.png
  1
  SAME)
itk_add_test(
  NAME
  itkConvolutionImageFilterTest5x5Mean
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest5x5Mean.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest5x5Mean.png
  itkConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/5x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest5x5Mean.png
  1
  SAME)
itk_add_test(
  NAME
  itkConvolutionImageFilterTest4x4MeanValidRegion
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest4x4MeanValidRegion.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x4MeanValidRegion.png
  itkConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x4-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x4MeanValidRegion.png
  1
  VALID)
itk_add_test(
  NAME
  itkConvolutionImageFilterTest4x5MeanValidRegion
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest4x5MeanValidRegion.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x5MeanValidRegion.png
  itkConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest4x5MeanValidRegion.png
  1
  VALID)
itk_add_test(
  NAME
  itkConvolutionImageFilterTest5x5MeanValidRegion
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest5x5MeanValidRegion.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest5x5MeanValidRegion.png
  itkConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/5x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterTest5x5MeanValidRegion.png
  1
  VALID)
itk_add_test(
  NAME
  itkConvolutionImageFilterDeltaFunctionTest
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Input/level.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterDeltaFunctionTest.png
  itkConvolutionImageFilterDeltaFunctionTest
  DATA{${ITK_DATA_ROOT}/Input/level.png}
  ${ITK_TEST_OUTPUT_DIR}/itkConvolutionImageFilterDeltaFunctionTest.png)

# FFT convolution tests
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTestSobelX
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkFFTConvolutionImageFilterTestSobelX.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelX.nrrd
  itkFFTConvolutionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/sobel_x.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelX.nrrd)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTestSobelY
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkFFTConvolutionImageFilterTestSobelY.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelY.nrrd
  itkFFTConvolutionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/sobel_y.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelY.nrrd)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTestSobelYPeriodic
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTestSobelYPeriodic.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelYPeriodic.nrrd
  itkFFTConvolutionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/sobel_y.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelYPeriodic.nrrd
  2
  0
  SAME
  PERIODIC)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTestSobelXConstant
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTestSobelXConstant.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelXConstant.nrrd
  itkFFTConvolutionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/sobel_x.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelXConstant.nrrd
  2
  0
  SAME
  CONSTANT)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTestSobelXZeroFluxNeumann
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTestSobelXZeroFluxNeumann.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelXZeroFluxNeumann.nrrd
  itkFFTConvolutionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/sobel_x.nii.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTestSobelXZeroFluxNeumann.nrrd
  2
  0
  VALID
  ZEROFLUXNEUMANN)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTest4x4Mean
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkFFTConvolutionImageFilterTest4x4Mean.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x4Mean.png
  itkFFTConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x4-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x4Mean.png
  1
  SAME)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTest4x5Mean
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest4x5Mean.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x5Mean.png
  itkFFTConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x5Mean.png
  1
  SAME)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTest5x5Mean
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest5x5Mean.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest5x5Mean.png
  itkFFTConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/5x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest5x5Mean.png
  1
  SAME)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTest4x4MeanValidRegion
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkFFTConvolutionImageFilterTest4x4MeanValidRegion.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x4MeanValidRegion.png
  itkFFTConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x4-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x4MeanValidRegion.png
  1
  VALID)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTest4x5MeanValidRegion
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest4x5MeanValidRegion.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x5MeanValidRegion.png
  itkFFTConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{Input/4x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest4x5MeanValidRegion.png
  1
  VALID)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterTest5x5MeanValidRegion
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkConvolutionImageFilterTest5x5MeanValidRegion.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest5x5MeanValidRegion.png
  itkFFTConvolutionImageFilterTestInt
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/5x5-constant.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterTest5x5MeanValidRegion.png
  1
  VALID)
itk_add_test(
  NAME
  itkFFTConvolutionImageFilterDeltaFunctionTest
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Input/level.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterDeltaFunctionTest.png
  itkFFTConvolutionImageFilterDeltaFunctionTest
  DATA{${ITK_DATA_ROOT}/Input/level.png}
  ${ITK_TEST_OUTPUT_DIR}/itkFFTConvolutionImageFilterDeltaFunctionTest.png
  5)

# NCC tests
itk_add_test(
  NAME
  itkNormalizedCorrelationImageFilterTest
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/BasicFilters/NormalizedCorrelationImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/NormalizedCorrelationImageFilterTest.png
  itkNormalizedCorrelationImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/sf4.png}
  DATA{${ITK_DATA_ROOT}/Input/circle.png}
  ${ITK_TEST_OUTPUT_DIR}/NormalizedCorrelationImageFilterTest.png)

# Masked FFT NCC tests
# Test with three different shapes
itk_add_test(
  NAME
  itkMaskedFFTNormalizedCorrelationImageFilterTest1
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkMaskedFFTNormalizedCorrelationImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaskedFFTNormalizedCorrelationImageFilterTest1.png
  itkMaskedFFTNormalizedCorrelationImageFilterTest
  DATA{Input/FixedRectangles.png}
  DATA{Input/MovingRectangles.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaskedFFTNormalizedCorrelationImageFilterTest1.png
  0.1
  DATA{Input/FixedRectangleMask1.png}
  DATA{Input/MovingRectanglesMask.png})
itk_add_test(
  NAME
  itkMaskedFFTNormalizedCorrelationImageFilterTest2
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkMaskedFFTNormalizedCorrelationImageFilterTest2.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaskedFFTNormalizedCorrelationImageFilterTest2.png
  itkMaskedFFTNormalizedCorrelationImageFilterTest
  DATA{Input/FixedRectangles.png}
  DATA{Input/MovingRectangles.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaskedFFTNormalizedCorrelationImageFilterTest2.png
  0.1
  DATA{Input/FixedRectangleMask2.png}
  DATA{Input/MovingRectanglesMask.png})
itk_add_test(
  NAME
  itkMaskedFFTNormalizedCorrelationImageFilterTest3
  COMMAND
  ITKConvolutionTestDriver
  --compare
  DATA{Baseline/itkMaskedFFTNormalizedCorrelationImageFilterTest3.png}

=== Modules/Filtering/FastMarching/src/CMakeLists.txt ===
set(ITKFastMarching_SRCS
    itkFastMarchingBase.cxx
    itkFastMarchingReachedTargetNodesStoppingCriterion.cxx
    itkFastMarchingImageFilter.cxx
    itkFastMarchingUpwindGradientImageFilter.cxx)

itk_module_add_library(ITKFastMarching ${ITKFastMarching_SRCS})

=== Modules/Filtering/ImageFusion/test/CMakeLists.txt ===
itk_module_test()
set(ITKImageFusionTests
    itkScalarToRGBPixelFunctorTest.cxx
    itkLabelOverlayImageFilterTest.cxx
    itkLabelToRGBImageFilterTest.cxx
    itkLabelMapToRGBImageFilterTest1.cxx
    itkLabelMapToRGBImageFilterTest2.cxx
    itkLabelMapContourOverlayImageFilterTest1.cxx
    itkLabelMapContourOverlayImageFilterTest2.cxx
    itkLabelMapContourOverlayImageFilterTest3.cxx
    itkLabelMapOverlayImageFilterTest1.cxx
    itkLabelMapOverlayImageFilterTest2.cxx
    itkLabelMapOverlayImageFilterTest3.cxx)

createtestdriver(ITKImageFusion "${ITKImageFusion-Test_LIBRARIES}" "${ITKImageFusionTests}")

itk_add_test(
  NAME
  itkScalarToRGBPixelFunctorTest
  COMMAND
  ITKImageFusionTestDriver
  itkScalarToRGBPixelFunctorTest)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_0
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_0Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_0Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.0
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_0Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_1
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_1Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_1Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.1
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_1Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_2
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_2Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_2Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.2
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_2Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_3
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_3Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_3Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.3
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_3Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_4
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_4Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_4Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.4
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_4Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_5
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_5Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_5Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.5
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_5Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_6
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_6Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_6Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.6
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_6Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_7
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_7Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_7Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.7
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_7Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_8
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_8Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_8Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.8
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_8Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-0_9
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-0_9Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_9Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  0.9
  ${ITK_TEST_OUTPUT_DIR}/cthead1-0_9Overlay.png)
itk_add_test(
  NAME
  itkLabelOverlayImageFilterTest-Opacity-1_0
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1-1_0Overlay.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-1_0Overlay.png
  itkLabelOverlayImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  1.0
  ${ITK_TEST_OUTPUT_DIR}/cthead1-1_0Overlay.png)
itk_add_test(
  NAME
  itkLabelToRGBImageFilterTest
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/cthead1Label-color.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1Label-color.png
  itkLabelToRGBImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1Label-color.png)
itk_add_test(
  NAME
  itkLabelMapToRGBImageFilterTest1
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapToRGBImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapToRGBImageFilterTest1.png
  itkLabelMapToRGBImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapToRGBImageFilterTest1.png)
itk_add_test(
  NAME
  itkLabelMapToRGBImageFilterTest2
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapToRGBImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapToRGBImageFilterTest2.png
  itkLabelMapToRGBImageFilterTest2
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapToRGBImageFilterTest2.png)
itk_add_test(
  NAME
  itkLabelMapContourOverlayImageFilterTest0
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapContourOverlayImageFilterTest0.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest0.png
  itkLabelMapContourOverlayImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  DATA{${ITK_DATA_ROOT}/Input/SpotsInverted.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest0.png
  0.6
  0
  0
  10
  1
  1)
itk_add_test(
  NAME
  itkLabelMapContourOverlayImageFilterTest1
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapContourOverlayImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest1.png
  itkLabelMapContourOverlayImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  DATA{${ITK_DATA_ROOT}/Input/SpotsInverted.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest1.png
  0.7
  1
  2
  15
  0
  1)
itk_add_test(
  NAME
  itkLabelMapContourOverlayImageFilterTest2
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapContourOverlayImageFilterTest2.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest2.png
  itkLabelMapContourOverlayImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  DATA{${ITK_DATA_ROOT}/Input/SpotsInverted.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest2.png
  0.8
  2
  3
  12
  1
  1)
itk_add_test(
  NAME
  itkLabelMapContourOverlayImageFilterTest3
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapContourOverlayImageFilterTest2.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest3.png
  itkLabelMapContourOverlayImageFilterTest2
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  DATA{${ITK_DATA_ROOT}/Input/SpotsInverted.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest3.png
  0.8
  2
  3
  12
  1)
itk_add_test(
  NAME
  itkLabelMapContourOverlayImageFilterTest4
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapContourOverlayImageFilterTest4.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest4.png
  itkLabelMapContourOverlayImageFilterTest3
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  DATA{${ITK_DATA_ROOT}/Input/SpotsInverted.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapContourOverlayImageFilterTest4.png
  0.7
  1
  2
  15
  0)

itk_add_test(
  NAME
  itkLabelMapOverlayImageFilterTest1
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapOverlayImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapOverlayImageFilterTest1.png
  itkLabelMapOverlayImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapOverlayImageFilterTest1.png
  0.3)
itk_add_test(
  NAME
  itkLabelMapOverlayImageFilterTest2
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapOverlayImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapOverlayImageFilterTest2.png
  itkLabelMapOverlayImageFilterTest2
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapOverlayImageFilterTest2.png
  0.3)
itk_add_test(
  NAME
  itkLabelMapOverlayImageFilterTest3
  COMMAND
  ITKImageFusionTestDriver
  --compare
  DATA{Baseline/itkLabelMapOverlayImageFilterTest3.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapOverlayImageFilterTest3.png
  itkLabelMapOverlayImageFilterTest3
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelMapOverlayImageFilterTest3.png
  0.3)

=== Modules/Filtering/ImageIntensity/src/CMakeLists.txt ===
set(ITKImageIntensity_SRCS itkSymmetricEigenAnalysisImageFilter.cxx)
### generating libraries
itk_module_add_library(ITKImageIntensity ${ITKImageIntensity_SRCS})

=== Modules/Filtering/ImageStatistics/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKImageStatistics)
itk_auto_load_and_end_wrap_submodules()

=== debian/changelog ===
insighttoolkit5 (5.4.3-5) unstable; urgency=medium

  * Team upload.
  * Make itkOptImageToImageMetricsTest04 not to fail on single-CPU systems.
    Closes: #1105896.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Thu, 22 May 2025 00:40:00 +0200

insighttoolkit5 (5.4.3-4) unstable; urgency=medium

  [ Steve Robbins ]
  * [1af5def] FFTW configuration needs itk configuration include.

 -- Steve M. Robbins <smr@debian.org>  Mon, 21 Apr 2025 23:48:27 -0500

insighttoolkit5 (5.4.3-3) unstable; urgency=medium

  * Release to unstable.

 -- Steve M. Robbins <smr@debian.org>  Sat, 19 Apr 2025 21:13:19 -0500

insighttoolkit5 (5.4.3-2) experimental; urgency=medium

  [ Steve Robbins ]
  * [00367e9] Fix build with gcc-15.  Closes: #1096841.

 -- Steve M. Robbins <smr@debian.org>  Fri, 18 Apr 2025 14:52:31 -0500

insighttoolkit5 (5.4.3-1) experimental; urgency=medium

  [ Steve Robbins ]
  * [72aaa69] Update import notes
  * [3bfd67a] New upstream version 5.4.3

 -- Steve M. Robbins <smr@debian.org>  Sun, 06 Apr 2025 13:03:40 -0500

=== debian/control ===
Source: insighttoolkit5
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Gert Wollny <gewo@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libvtk9-dev, libvtk9-qt-dev,
               zlib1g-dev,
               libdouble-conversion-dev,
               libexpat-dev,
               libpng-dev,
               libtiff-dev,
               libfftw3-dev,
               libdcmtk-dev,
               libgdcm-dev,
               libgtest-dev,
               uuid-dev,
               libminc-dev,
               libnifti2-dev,
               libhdf5-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/insighttoolkit
Vcs-Git: https://salsa.debian.org/med-team/insighttoolkit.git
Homepage: http://www.itk.org/
Rules-Requires-Root: no

Package: libinsighttoolkit5.4
Architecture: amd64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Image processing toolkit for registration and segmentation - runtime
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the libraries needed to run ITK applications.

Package: libinsighttoolkit5-dev
Architecture: amd64
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libinsighttoolkit5.4 (= ${binary:Version}),
         libvtk9-dev, libvtk9-qt-dev,
         libgdcm-dev,
         libdcmtk-dev,
         libhdf5-dev,
         libdouble-conversion-dev,
         libexpat-dev,
         libnifti-dev,
         libminc-dev
Recommends: libfftw3-dev,
            uuid-dev
Suggests: insighttoolkit5-examples
Conflicts: libinsighttoolkit-dev,
           libinsighttoolkit3-dev,
           libinsighttoolkit4-dev
Replaces: libinsighttoolkit-dev,
          libinsighttoolkit3-dev,
          libinsighttoolkit4-dev
Description: Image processing toolkit for registration and segmentation - development
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the development files needed to build your own
 ITK applications.

Package: insighttoolkit5-examples
Architecture: all
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libinsighttoolkit5-dev
Multi-Arch: foreign
Description: Image processing toolkit for registration and segmentation - examples
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the source for example programs.

=== debian/rules ===
#!/usr/bin/make -f

VER_MAJOR = 5
VER_MINOR = 4
VER_REVISION = 3
VERSION = $(VER_MAJOR).$(VER_MINOR).$(VER_REVISION)
SOVERSION = $(VER_MAJOR).$(VER_MINOR)

#ITK is not properly using system provided headers
export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/nifti -g1

ENABLE_FFTW=ON
ENABLE_UNSIGNED_LONG_LONG=ON

ifeq ($(DEB_HOST_ARCH),i386)
  ENABLE_FFTW=OFF
#(unsigned long) == (unsigned int) on 32 bit, since itk 4.10 or g++-5.4
  ENABLE_UNSIGNED_LONG_LONG=OFF
  DEB_CMAKEFLAGS_MAINT_APPEND = -DITK_COMPUTER_MEMORY_SIZE=2
  # Tests are permanently failing, try force rounding to normal double
  # accuracy
  export DEB_CXXFLAGS_MAINT_APPEND=-ffloat-store
endif

CMAKE_FLAGS = \
	-DBUILD_EXAMPLES:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=ON \
	-DExternalData_OBJECT_STORES:PATH=$(CURDIR)/data/.ExternalData/ \
	-DCMAKE_EXPORT_COMPILE_COMMANDS:BOOL=ON \
	-DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DUSE_FFTWF=$(ENABLE_FFTW) \
	-DITK_FORBID_DOWNLOADS:BOOL=ON \
	-DITK_USE_FFTWD:BOOL=$(ENABLE_FFTW) \
	-DITK_USE_FFTWF:BOOL=$(ENABLE_FFTW) \
	-DITK_USE_SYSTEM_DCMTK:BOOL=ON \
	-DITK_USE_SYSTEM_DOUBLECONVERSION:BOOL=OFF \
	-DITK_USE_SYSTEM_EXPAT:BOOL=ON \
	-DITK_USE_SYSTEM_FFTW:BOOL=$(ENABLE_FFTW) \
	-DITK_USE_SYSTEM_GDCM:BOOL=ON \
	-DITK_USE_SYSTEM_GOOGLETEST:BOOL=ON \
	-DGTEST_SRC=/usr/src/googletest/googletest \
	-DITK_USE_SYSTEM_MINC:BOOL=ON \
	-DITK_USE_SYSTEM_HDF5:BOOL=ON \
	-DITK_USE_SYSTEM_JPEG:BOOL=ON \
	-DITK_USE_SYSTEM_PNG:BOOL=ON \
	-DITK_USE_SYSTEM_TIFF:BOOL=OFF \
	-DITK_USE_SYSTEM_VXL:BOOL=OFF \
	-DITK_USE_SYSTEM_ZLIB:BOOL=ON \
	-DITK_USE_KWSTYLE:BOOL=OFF \
	-DModule_ITKDCMTK:BOOL=ON \
	-DModule_ITKIOPhilipsREC:BOOL=OFF \
	-DModule_ITKLevelSetsv4Visualization:BOOL=OFF \
	-DModule_BridgeNumPy:BOOL=OFF \
	-DModule_ITKVideoBridgeOpenCV:BOOL=OFF \
	-DModule_ITKVideoBridgeVXL:BOOL=OFF \
	-DModule_ITKVtkGlue:BOOL=ON \
	-DModule_ITKReview:BOOL=ON \
	-DVCL_INCLUDE_CXX_0X:BOOL=ON \
	-DITK_USE_SYSTEM_SWIG:BOOL=ON \
	-DITK_USE_SYSTEM_CASTXML:BOOL=ON \
	-DITK_WRAP_IMAGE_DIMS="2;3" \
	-DITK_WRAP_unsigned_long_long:BOOL=$(ENABLE_UNSIGNED_LONG_LONG) \
	-DITK_WRAP_double:BOOL=ON \
	-DITK_WRAP_vector_double:BOOL=ON \
	-DITK_WRAP_covariant_vector_double:BOOL=ON \
	-DITK_WRAP_complex_double:BOOL=ON \
	-DITK_COMPUTER_MEMORY_SIZE:STRING="2" \
	$(DEB_CMAKEFLAGS_MAINT_APPEND)

pkg_lib = libinsighttoolkit$(SOVERSION)
pkg_dev = libinsighttoolkit$(VER_MAJOR)-dev
pkg_examples = insighttoolkit$(VER_MAJOR)-examples


%:
	dh $@ --builddir=BUILD

override_dh_auto_configure-indep:

override_dh_auto_configure-arch: pre-build
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_build-indep:

pre-build:
	echo "Available disk space (~50GB of space is needed for the build):"
	df -h .

override_dh_auto_test-indep:

override_dh_auto_test:
	LD_LIBRARY_PATH=`pwd`/BUILD/lib:`pwd`/BUILD/Testing/Temporary ARGS="--label-exclude REQUIRES_DISPLAY" dh_auto_test || \
    ( echo "Test log begin =========:"  \
    && cat `pwd`/BUILD/Testing/Temporary/LastTest.log \
    && echo "Test log end =========:" \
    && exit 1 )

override_dh_lintian:
	echo "#ITK embeds various patched libraries" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): package-name-doesnt-match-sonames" >> debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): shared-library-lacks-prerequisites" >> debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): library-not-linked-against-libc [usr/lib/*/libITK*]" >> debian/$(pkg_lib).lintian-overrides
	echo "${pkg_dev}: no-manual-page [usr/bin/itkTestDriver]" > debian/$(pkg_dev).lintian-overrides
	dh_lintian

override_dh_install-indep:

override_dh_install-arch:
	# pkg_lib
	dh_install -p$(pkg_lib) --autodest -XJava -XPython -XTcl debian/tmp/usr/lib/*/lib*.so.*
	cp CMake/InsightValgrind.supp Insight$(SOVERSION)Valgrind.supp
#	cp Modules/ThirdParty/VNL/src/vxl/config/valgrind.supp Insight$(SOVERSION)VxlValgrind.supp
	dh_install -p$(pkg_lib) Insight$(SOVERSION)*.supp usr/lib/valgrind
	#
	# pkg_dev
	dh_installman -p$(pkg_dev) debian/insighttoolkit.3
	dh_install -p$(pkg_dev) --autodest -XJava -XPython -XTcl debian/tmp/usr/lib/*/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/ITK-$(SOVERSION)/*
	# The itkTestDriver seems to be required due to references in /usr/lib/cmake files; c.f. Bug #700723
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/itkTestDriver

	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/*/cmake
	# remove build directory to save space
	rm -rf BUILD debian/tmp

override_dh_installexamples:
	# pkg_examples
	dh_installexamples -p$(pkg_examples) Examples/*
ifneq (,$(filter $(pkg_examples), $(shell dh_listpackages)))
	find debian/$(pkg_examples)/usr/share/doc/$(pkg_examples)/examples \
	    -type f -print0 | xargs -0 chmod 644
endif

override_dh_clean:
	# Modules/ThirdParty/pygccxml/src/pygccxml leaves build artifacts around
	find  Modules/ThirdParty/pygccxml/src -name __pycache__ -execdir rm -r '{}' +
	dh_clean

control-file:
	sed -e "s/@VER_MAJOR@/$(VER_MAJOR)/g" \
	    -e "s/@SOVERSION@/$(SOVERSION)/g" \
	    < debian/control.in > debian/control.tmp
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control

# The Debian source tarball is created by combining the upstream source and data tarballs
# For ITK 5.4.3 this was done manually:
#
# 1. Download manually:
#    a. https://github.com/InsightSoftwareConsortium/ITK/releases/download/v5.4.3/InsightToolkit-5.4.3.tar.gz
#    b. https://github.com/InsightSoftwareConsortium/ITK/releases/download/v5.4.3/InsightData-5.4.3.tar.gz
#
# 2. Extract in "tarballs", create new merged source tarball:
#    mv ~/Downloads/Insight* .
#    tar xzf InsightToolkit-5.4.3.tar.gz
#    tar xzf InsightData-5.4.3.tar.gz
#    tar --xz -cf insighttoolkit5_5.4.3.orig.tar.xz InsightToolkit-5.4.3
#
# 3. Import into GIT
#    gbp import-orig --pristine-tar ../tarballs/insighttoolkit5_5.4.3.orig.tar.xz

TARBALLDIR = "../tarballs"
get-orig-source:
	echo "Create manually; see rules"
	#uscan --watchfile debian/data/watch --force-download --no-symlink --destdir $(TARBALLDIR)
	#uscan --force-download --rename --destdir $(TARBALLDIR)
	#cd $(TARBALLDIR) && mv `ls InsightData-$(VERSION).tar.xz` insighttoolkit$(VER_MAJOR)_$(VERSION)-dfsg1.orig-data.tar.xz
